#include "Arduino.h"
#include "ParticleFilter.h"

ParticleFilter::ParticleFilter(){
  
}
   public void newWeight(){
        
    
    
    }
    
    public Coordinate weightedAveragePosition(){
        double X = 0;
        double Y = 0;
        float angle = 0;//neu 
        
        for(int i = 0;i<particleArray.length;i++){
            tempParticle = particleArray[i];
            tempWeight = tempParticle.getWeight();
            tempPos = tempParticle.getPos();
            
            tempX = tempPos.getX();  //nicht implementiert
            tempY = tempPos.getY();  //nicht implementiert
            tempAngle = tempPos.getAngle();// neu
            
            tempX = tempX * tempWeight;
            tempY = tempY * tempWeight;
            X += tempX;
            Y += tempY;
            
        }
        X = X/particleArray.length;
        Y = Y/particleArray.length;
    }
    
    
    
    public void resampleFilter(){   //Resampling nach SIR(Sequencial Importance Resampling)
        double[] weightArray = new double[particleArray.length];
        double current = 0;
        double sum = 0;
        for (int i = 0; i<particleArray.length;i++){
            current = particleArray[i].getWeight();
            weightArray[i] = sum + current;
            sum = weightArray[i];
        }
        Particle[] newParticleArray = new Particle[];
        int PIndex = 0;
        for(int i = 0; i<particleArray.length;i++){
            pseudorandom =( rand() % particleArray.length) / particleArray.length; //generiert eine zahl zwischen 0 und 1...hoffentlich
            
            for(int j = 0; j<weightArray.length; j++ ){  // diese for-schleife sucht den particle nach non-uniform pseudo-random variate generation
                if(pseudorandom > weightArray[j]){
                    continue;
                } else {
                    PIndex = j;    
                }
            }
            
            newParticleArray[i] = particleArray[PIndex]; // füllt ein neues array mit den zugeordneten werten
            
        }
        
        for(int i = 0;i<newParticleArray.length;i++){
            particleArray[i] = newParticleArray[i];
        }
        
    }

