#include "Arduino.h"

class Sensorturm {
  
  public:
  
  void erhebeDaten(boolean signal);
  void messeEntfernung();
  void starteSuchlauf();
  
  
  private:
  
  boolean erfässtDaten();
  void steppe();
  int findeBake(int[] bakencode);
  
  Bakenwert[] bakenwerte;
  int steps;
  int[] entfernungen;
  
};


Funktionen:

erfässtDaten(param: / , return: boolean signal)  // gibt true zurück falls ein signal gefunden wird, sonst false
erhebeDaten(param: boolean signal , return: /) //falls ein signal gefunden worden ist, vergleicht den gefundenen bakencode mit gespeicherten, und verändert von der gefundenen bake dann die bakenwerte
messeEntfernung(param: / , return: /)  // misst die entfernung zum nächsten objekt(maximal 2 meter). dauert 25 millis und misst mit cm-genauigkeit.

starteSuchlauf(param: / , return: /)  // startet einen signal-suchlauf. macht solange steps bis ein signal gefunden wird, geht dann in einen erhebungs-algo über, danach wieder suchlauf nach komplettierung eines laufes werden die bakenwerte resettet(außer offset))
steppe(param: / , return: /)  // macht einen motorstep und zählt steps hoch
findeBake(param: int[] bakencode , return: int bakennummer)  // gibt eine id zurück, die der gefundenen Bake entspricht

Felder:

int steps  // die derzeitige anzahl steps die der motor gelaufen ist
Bakenwert[] bakenwerte  // ein array mit den werten aller drei baken
int[] entfernungen  // die entfernung als spannungswert(0-1024) für jeden step im kreis

Skizzen:

ablauf des startups:

-eine umdrehung(bestimmung der offsetwerte)
-reset der bakenwerte
-eine umdrehung(positionsbestimmung)
- X drehungen(positionsbestätigung)

ablauf einer umdrehung:

-suche eines signals(steppe bis signalfund & messeEntfernung)

->fund eines signals
  -erhebeDaten
  -messeEntfernung
  -steppe 1x
  -wiederholung bis signalverlust

suche eines signals(steppe bis signalfund oder kreisvervollständigung)  
